// turmuhr.h
// enthält die funktionen zum ausschieben der bitmuster an die Neopixel

// definition Ausgangspin
#define PIN            2  // ist PIN D4 am Wemos D1

// definition Anzahl der Pixel

#ifdef LITLE
 #define NUMPIXELS      28
#else
 #define NUMPIXELS      47
#endif

int sekunden = 45 ;
int minuten = 24 ;
int stunden = 14 ;
int temp1 = 0 ;
int next_showtime =  15 ; //erste Lightshow, ab dann zufällig

#include <Adafruit_NeoPixel.h>

// When we setup the NeoPixel library, we tell it how many pixels, and which pin to use to send signals.
// Note that for older NeoPixel strips you might need to change the third parameter--see the strandtest
// example for more information on possible values.
Adafruit_NeoPixel pixels = Adafruit_NeoPixel(NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);

void shiftout_light (int startpos, int bits, int color_red, int color_green, int color_blue)   // Parameter übernehmen
{ for (int i = 0; i < bits; i++) {
    pixels.setPixelColor(startpos + i, pixels.Color(color_red, color_green, color_blue));
    pixels.show(); // This sends the updated pixel color to the hardware.
  }
}


void shiftout_bits (int startpos, int bits, int value, int color_red, int color_green, int color_blue)   // Parameter übernehmen
{ for (int i = 0; i < bits; i++) // Hauptschleifenzähler, Anzahl der auszugebenden Bits
  { if (value > i) //Wert ist größer als Schleifenzähler
    { 
      #ifdef FIRE
      color_red = random(cnt_rf_min, cnt_rf_max); // Feuerflackern
      color_green = 30;
      #endif
      pixels.setPixelColor(startpos + i, pixels.Color(color_red, color_green, color_blue)); //send Bit out
      //pixels.show(); // This sends the updated pixel color to the hardware.
      //delay(delayval); // Delay for a period of time (in milliseconds).
    }
    else // Aktion bei Low Bit
    { pixels.setPixelColor(startpos + i, pixels.Color(0, 0, 0)); //send Bit out
      //pixels.show(); // This sends the updated pixel color to the hardware.
      //delay(delayval); // Delay for a period of time (in milliseconds).
    }
  }
  pixels.show();
  return; // Funtion wieder verlassen
}

// Lightshow zum start
void lightshow_1 (int slow)
{
  int  rd = 0;
  int  gn = 0;
  int  bu = 0;

  //red
  for (int x = 0; x < 100; x++) {
    delay(slow);
    rd++ ;
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }
    pixels.show(); // This sends the updated pixel color to the hardware.
  }
  rd = 0;
  //green
  for (int x = 0; x < 100; x++) {
    delay(slow);
    gn++ ;
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }
    pixels.show(); // This sends the updated pixel color to the hardware.

  }
  gn = 0;

  //blue
  for (int x = 0; x < 100; x++) {
    delay(slow);
    bu++ ;
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }
    pixels.show(); // This sends the updated pixel color to the hardware.

  }
  bu = 0;


  //white
  for (int x = 0; x < 100; x++) {
    delay(slow);
    rd++ ; gn++ ; bu++ ;
    for (int i = 0; i < NUMPIXELS; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }
    pixels.show(); // This sends the updated pixel color to the hardware.

  }
  for (int i = 0; i < NUMPIXELS; i++) {
    pixels.setPixelColor(i, pixels.Color(0, 0, 0));
  }
  pixels.show(); // This sends the updated pixel color to the hardware.

  return; // Funtion wieder verlassen
}



// Lightshow zur Vollen Stunde
void lightshow_2 (int slow)
{
  int  rd = 0;
  int  gn = 0;
  int  bu = 0;

 //white
  for (int x = 0; x < 100; x++) {
    delay(slow);
    rd++ ; gn++ ; bu++ ;
    for (int i = 0; i < 15; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }

    for (int i = 17; i < 32; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }

    for (int i = 34; i < 46; i++) {
      pixels.setPixelColor(i, pixels.Color(rd, gn, bu));
    }
    
    pixels.show(); // This sends the updated pixel color to the hardware.
    }

  return; // Funtion wieder verlassen
}


#ifdef LITLE // Anzeige für "Little DragonClock" mit einzelenen Trennern
void show_out() //Ausgabe der Zeitanzeige zum Turm
{

  // Trennstelle / Sekundenblinker ausgeben

  if (sekunden % 2 == 0) {
    shiftout_light(0, 1, 40, 0, 0); // einzelne;
  } else {
   shiftout_light(0, 1, 60, 30, 0);;
  }
  
 // shiftout_light(0, 1, trenn_r, trenn_g, trenn_b); // einzelne
  
  //minutenen Einerstelle ausgeben
  temp1 = minuten % 10 ;
  shiftout_bits(1, 9, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(10, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
  //minuten Zehnerstelle ausgeben
  temp1 = minuten / 10 ;
  shiftout_bits(11, 5, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen

  // Trennstelle ausgeben
  shiftout_light(16, 2, trenn_r, trenn_g, trenn_b); // einzelne
  //stunden Einerstelle ausgeben
  temp1 = stunden % 10 ;
  shiftout_bits(18, 9, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(27, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
  //stunden Zehnerstelle ausgeben
  temp1 = stunden / 10 ;
  shiftout_bits(28, 2, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(30, 2, trenn_r, trenn_g, trenn_b); // einzelne Lampe
}

#else // Anzeige für "NORMALE DragonClock" mit zwei Trennern
void show_out() //Ausgabe der Zeitanzeige zum Turm
{
  //sekunden Einerstelle ausgeben
  temp1 = sekunden % 10 ;
  shiftout_bits(0, 9, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(9, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
  //sekunden Zehnerstelle ausgeben
  temp1 = sekunden / 10 ;
  shiftout_bits(10, 5, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen

  // Trennstellen ausgeben
  shiftout_light(15, 2, trenn_r, trenn_g, trenn_b); // einzelne
  //minutenen Einerstelle ausgeben
  temp1 = minuten % 10 ;
  shiftout_bits(17, 9, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(26, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
  //minuten Zehnerstelle ausgeben
  temp1 = minuten / 10 ;
  shiftout_bits(27, 5, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen

  // Trennstelle ausgeben
  shiftout_light(32, 2, trenn_r, trenn_g, trenn_b); // einzelne
  //stunden Einerstelle ausgeben
  temp1 = stunden % 10 ;
  shiftout_bits(34, 9, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(43, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
  //stunden Zehnerstelle ausgeben
  temp1 = stunden / 10 ;
  shiftout_bits(44, 2, temp1, cnt_r, cnt_g, cnt_b); // Funktion Bitszählen und Muster ausgeben aufrufen
  // Trennstelle ausgeben
  shiftout_light(46, 1, trenn_r, trenn_g, trenn_b); // einzelne Lampe
}

#endif
